chiark / gitweb /
f1b323b7cbe543994f373523ab2b84b814fd0adc
[topgit.git] / tg.sh
1 #!/bin/sh
2 # TopGit - A different patch queue manager
3 # (c) Petr Baudis <pasky@suse.cz>  2008
4 # GPLv2
5
6 TG_VERSION=0.8
7
8 ## Auxiliary functions
9
10 info()
11 {
12         echo "${TG_RECURSIVE}tg: $*"
13 }
14
15 die()
16 {
17         info "fatal: $*" >&2
18         exit 1
19 }
20
21 # cat_file "topic:file"
22 # Like `git cat-file blob $1`, but topics '(i)' and '(w)' means index and worktree
23 cat_file()
24 {
25         arg="$1"
26         case "$arg" in
27         '(w):'*)
28                 cat "${arg#(w):}"
29                 ;;
30         '(i):'*)
31                 # ':file' means cat from index
32                 git cat-file blob "${arg#(i)}"
33                 ;;
34         *)
35                 git cat-file blob "$arg"
36                 ;;
37         esac
38 }
39
40 # get tree for the committed topic
41 get_tree_()
42 {
43         echo "$1"
44 }
45
46 # get tree for the base
47 get_tree_b()
48 {
49         echo "refs/top-bases/$1"
50 }
51
52 # get tree for the index
53 get_tree_i()
54 {
55         git write-tree
56 }
57
58 # get tree for the worktree
59 get_tree_w()
60 {
61         i_tree=$(git write-tree)
62         (
63                 # the file for --index-output needs to sit next to the
64                 # current index file
65                 : ${GIT_INDEX_FILE:="$git_dir/index"}
66                 TMP_INDEX="$(mktemp "${GIT_INDEX_FILE}-tg.XXXXXX")"
67                 git read-tree -m $i_tree --index-output="$TMP_INDEX" &&
68                 GIT_INDEX_FILE="$TMP_INDEX" &&
69                 export GIT_INDEX_FILE &&
70                 git diff --name-only -z HEAD |
71                         git update-index -z --add --remove --stdin &&
72                 git write-tree &&
73                 rm -f "$TMP_INDEX"
74         )
75 }
76
77 # pretty_tree NAME [-b | -i | -w]
78 # Output tree ID of a cleaned-up tree without tg's artifacts.
79 # NAME will be ignored for -i and -w, but needs to be present
80 pretty_tree()
81 {
82         name=$1
83         source=${2#?}
84         git ls-tree --full-tree "$(get_tree_$source "$name")" |
85                 awk -F '        ' '$2 !~ /^.top/' |
86                 git mktree
87 }
88
89 # setup_hook NAME
90 setup_hook()
91 {
92         hook_call="\"\$($tg --hooks-path)\"/$1 \"\$@\""
93         if [ -f "$git_dir/hooks/$1" ] &&
94            fgrep -q "$hook_call" "$git_dir/hooks/$1"; then
95                 # Another job well done!
96                 return
97         fi
98         # Prepare incantation
99         if [ -x "$git_dir/hooks/$1" ]; then
100                 hook_call="$hook_call"' || exit $?'
101         else
102                 hook_call="exec $hook_call"
103         fi
104         # Don't call hook if tg is not installed
105         hook_call="if which \"$tg\" > /dev/null; then $hook_call; fi"
106         # Insert call into the hook
107         {
108                 echo "#!/bin/sh"
109                 echo "$hook_call"
110                 [ ! -s "$git_dir/hooks/$1" ] || cat "$git_dir/hooks/$1"
111         } >"$git_dir/hooks/$1+"
112         chmod a+x "$git_dir/hooks/$1+"
113         mv "$git_dir/hooks/$1+" "$git_dir/hooks/$1"
114 }
115
116 # setup_ours (no arguments)
117 setup_ours()
118 {
119         if [ ! -s "$git_dir/info/attributes" ] || ! grep -q topmsg "$git_dir/info/attributes"; then
120                 {
121                         echo ".topmsg   merge=ours"
122                         echo ".topdeps  merge=ours"
123                 } >>"$git_dir/info/attributes"
124         fi
125         if ! git config merge.ours.driver >/dev/null; then
126                 git config merge.ours.name '"always keep ours" merge driver'
127                 git config merge.ours.driver 'touch %A'
128         fi
129 }
130
131 # measure_branch NAME [BASE]
132 measure_branch()
133 {
134         _bname="$1"; _base="$2"
135         [ -n "$_base" ] || _base="refs/top-bases/$_bname"
136         # The caller should've verified $name is valid
137         _commits="$(git rev-list "$_bname" ^"$_base" -- | wc -l)"
138         _nmcommits="$(git rev-list --no-merges "$_bname" ^"$_base" -- | wc -l)"
139         if [ $_commits -gt 1 ]; then
140                 _suffix="commits"
141         else
142                 _suffix="commit"
143         fi
144         echo "$_commits/$_nmcommits $_suffix"
145 }
146
147 # branch_contains B1 B2
148 # Whether B1 is a superset of B2.
149 branch_contains()
150 {
151         [ -z "$(git rev-list --max-count=1 ^"$1" "$2" --)" ]
152 }
153
154 # ref_exists REF
155 # Whether REF is a valid ref name
156 ref_exists()
157 {
158         git rev-parse --verify "$@" >/dev/null 2>&1
159 }
160
161 # has_remote BRANCH
162 # Whether BRANCH has a remote equivalent (accepts top-bases/ too)
163 has_remote()
164 {
165         [ -n "$base_remote" ] && ref_exists "remotes/$base_remote/$1"
166 }
167
168 branch_annihilated()
169 {
170         _name="$1";
171
172         # use the merge base in case the base is ahead.
173         mb="$(git merge-base "refs/top-bases/$_name" "$_name")";
174
175         test "$(git rev-parse "$mb^{tree}")" = "$(git rev-parse "$_name^{tree}")";
176 }
177
178 # is_sha1 REF
179 # Whether REF is a SHA1 (compared to a symbolic name).
180 is_sha1()
181 {
182         [ "$(git rev-parse "$1")" = "$1" ]
183 }
184
185 # recurse_deps CMD NAME [BRANCHPATH...]
186 # Recursively eval CMD on all dependencies of NAME.
187 # CMD can refer to $_name for queried branch name,
188 # $_dep for dependency name,
189 # $_depchain for space-seperated branch backtrace,
190 # and the $_dep_is_tgish boolean.
191 # It can modify $_ret to affect the return value
192 # of the whole function.
193 # If recurse_deps() hits missing dependencies, it will append
194 # them to space-separated $missing_deps list and skip them.
195 # remote dependencies are processed if no_remotes is unset.
196 recurse_deps()
197 {
198         _cmd="$1"; shift
199         _name="$1"; # no shift
200         _depchain="$*"
201
202         _depsfile="$(mktemp -t tg-depsfile.XXXXXX)"
203         # If no_remotes is unset check also our base against remote base.
204         # Checking our head against remote head has to be done in the helper.
205         if test -z "$no_remotes" && has_remote "top-bases/$_name"; then
206                 echo "refs/remotes/$base_remote/top-bases/$_name" >>"$_depsfile"
207         fi
208
209         # if the branch was annihilated, there exists no .topdeps file
210         if ! branch_annihilated "$_name"; then
211                 #TODO: handle nonexisting .topdeps?
212                 git cat-file blob "$_name:.topdeps" >>"$_depsfile";
213         fi;
214
215         _ret=0
216         while read _dep; do
217                 if ! ref_exists "$_dep" ; then
218                         # All hope is lost
219                         missing_deps="$missing_deps $_dep"
220                         continue
221                 fi
222
223                 _dep_is_tgish=1
224                 ref_exists "refs/top-bases/$_dep"  ||
225                         _dep_is_tgish=
226
227                 # Shoo shoo, keep our environment alone!
228                 [ -z "$_dep_is_tgish" ] ||
229                         (recurse_deps "$_cmd" "$_dep" "$@") ||
230                         _ret=$?
231
232                 eval "$_cmd"
233         done <"$_depsfile"
234         missing_deps="${missing_deps# }"
235         rm "$_depsfile"
236         return $_ret
237 }
238
239 # branch_needs_update
240 # This is a helper function for determining whether given branch
241 # is up-to-date wrt. its dependencies. It expects input as if it
242 # is called as a recurse_deps() helper.
243 # In case the branch does need update, it will echo it together
244 # with the branch backtrace on the output (see needs_update()
245 # description for details) and set $_ret to non-zero.
246 branch_needs_update()
247 {
248         _dep_base_update=
249         if [ -n "$_dep_is_tgish" ]; then
250                 if has_remote "$_dep"; then
251                         branch_contains "$_dep" "refs/remotes/$base_remote/$_dep" || _dep_base_update=%
252                 fi
253                 # This can possibly override the remote check result;
254                 # we want to sync with our base first
255                 branch_contains "$_dep" "refs/top-bases/$_dep" || _dep_base_update=:
256         fi
257
258         if [ -n "$_dep_base_update" ]; then
259                 # _dep needs to be synced with its base/remote
260                 echo "$_dep_base_update $_dep $_depchain"
261                 _ret=1
262         elif [ -n "$_name" ] && ! branch_contains "refs/top-bases/$_name" "$_dep"; then
263                 # Some new commits in _dep
264                 echo "$_dep $_depchain"
265                 _ret=1
266         fi
267 }
268
269 # needs_update NAME
270 # This function is recursive; it outputs reverse path from NAME
271 # to the branch (e.g. B_DIRTY B1 B2 NAME), one path per line,
272 # inner paths first. Innermost name can be ':' if the head is
273 # not in sync with the base or '%' if the head is not in sync
274 # with the remote (in this order of priority).
275 # It will also return non-zero status if NAME needs update.
276 # If needs_update() hits missing dependencies, it will append
277 # them to space-separated $missing_deps list and skip them.
278 needs_update()
279 {
280         recurse_deps branch_needs_update "$@"
281 }
282
283 # branch_empty NAME
284 branch_empty()
285 {
286         [ -z "$(git diff-tree "refs/top-bases/$1" "$1" -- | fgrep -v "  .top")" ]
287 }
288
289 # list_deps
290 list_deps()
291 {
292         git for-each-ref refs/top-bases |
293                 while read rev type ref; do
294                         name="${ref#refs/top-bases/}"
295                         if branch_annihilated "$name"; then
296                                 continue;
297                         fi
298
299                         git cat-file blob "$name:.topdeps" | while read dep; do
300                                 dep_is_tgish=true
301                                 ref_exists "refs/top-bases/$dep"  ||
302                                         dep_is_tgish=false
303                                 if ! "$dep_is_tgish" || ! branch_annihilated $dep; then
304                                         echo "$name $dep"
305                                 fi
306                         done
307                 done
308 }
309
310 # switch_to_base NAME [SEED]
311 switch_to_base()
312 {
313         _base="refs/top-bases/$1"; _seed="$2"
314         # We have to do all the hard work ourselves :/
315         # This is like git checkout -b "$_base" "$_seed"
316         # (or just git checkout "$_base"),
317         # but does not create a detached HEAD.
318         git read-tree -u -m HEAD "${_seed:-$_base}"
319         [ -z "$_seed" ] || git update-ref "$_base" "$_seed"
320         git symbolic-ref HEAD "$_base"
321 }
322
323 # Show the help messages.
324 do_help()
325 {
326         if [ -z "$1" ] ; then
327                 # This is currently invoked in all kinds of circumstances,
328                 # including when the user made a usage error. Should we end up
329                 # providing more than a short help message, then we should
330                 # differentiate.
331                 # Petr's comment: http://marc.info/?l=git&m=122718711327376&w=2
332
333                 ## Build available commands list for help output
334
335                 cmds=
336                 sep=
337                 for cmd in "@cmddir@"/tg-*; do
338                         ! [ -r "$cmd" ] && continue
339                         # strip directory part and "tg-" prefix
340                         cmd="$(basename "$cmd")"
341                         cmd="${cmd#tg-}"
342                         cmds="$cmds$sep$cmd"
343                         sep="|"
344                 done
345
346                 echo "TopGit v$TG_VERSION - A different patch queue manager"
347                 echo "Usage: tg [-r REMOTE] ($cmds|help) ..."
348         elif [ -r "@cmddir@"/tg-$1 ] ; then
349                 setup_pager
350                 @cmddir@/tg-$1 -h 2>&1 || :
351                 echo
352                 if [ -r "@sharedir@/tg-$1.txt" ] ; then
353                         cat "@sharedir@/tg-$1.txt"
354                 fi
355         else
356                 echo "`basename $0`: no help for $1" 1>&2
357                 do_help
358                 exit 1
359         fi
360 }
361
362 ## Pager stuff
363
364 # isatty FD
365 isatty()
366 {
367         test -t $1
368 }
369
370 # setup_pager
371 # Spawn pager process and redirect the rest of our output to it
372 setup_pager()
373 {
374         isatty 1 || return 0
375
376         # TG_PAGER = GIT_PAGER | PAGER | less
377         # NOTE: GIT_PAGER='' is significant
378         TG_PAGER=${GIT_PAGER-${PAGER-less}}
379
380         [ -z "$TG_PAGER"  -o  "$TG_PAGER" = "cat" ]  && return 0
381
382
383         # now spawn pager
384         export LESS="${LESS:-FRSX}"     # as in pager.c:pager_preexec()
385
386         _pager_fifo_dir="$(mktemp -t -d tg-pager-fifo.XXXXXX)"
387         _pager_fifo="$_pager_fifo_dir/0"
388         mkfifo -m 600 "$_pager_fifo"
389
390         "$TG_PAGER" < "$_pager_fifo" &
391         exec > "$_pager_fifo"           # dup2(pager_fifo.in, 1)
392
393         # this is needed so e.g. `git diff` will still colorize it's output if
394         # requested in ~/.gitconfig with color.diff=auto
395         export GIT_PAGER_IN_USE=1
396
397         # atexit(close(1); wait pager)
398         trap "exec >&-; rm \"$_pager_fifo\"; rmdir \"$_pager_fifo_dir\"; wait" EXIT
399 }
400
401 ## Startup
402
403 [ -d "@cmddir@" ] ||
404         die "No command directory: '@cmddir@'"
405
406 ## Initial setup
407
408 set -e
409 git_dir="$(git rev-parse --git-dir)"
410 root_dir="$(git rev-parse --show-cdup)"; root_dir="${root_dir:-.}"
411 # Make sure root_dir doesn't end with a trailing slash.
412 root_dir="${root_dir%/}"
413 base_remote="$(git config topgit.remote 2>/dev/null)" || :
414 tg="tg"
415 # make sure merging the .top* files will always behave sanely
416 setup_ours
417 setup_hook "pre-commit"
418
419 ## Dispatch
420
421 # We were sourced from another script for our utility functions;
422 # this is set by hooks.  Skip the rest of the file.  A simple return doesn't
423 # work as expected in every shell.  See http://bugs.debian.org/516188
424 if [ -z "$tg__include" ]; then
425
426 if [ "$1" = "-r" ]; then
427         shift
428         if [ -z "$1" ]; then
429                 echo "Option -r requires an argument." >&2
430                 do_help
431                 exit 1
432         fi
433         base_remote="$1"; shift
434         tg="$tg -r $base_remote"
435 fi
436
437 cmd="$1"
438 [ -n "$cmd" ] || { do_help; exit 1; }
439 shift
440
441 case "$cmd" in
442 help|--help|-h)
443         do_help "$1"
444         exit 0;;
445 --hooks-path)
446         # Internal command
447         echo "@hooksdir@";;
448 *)
449         [ -r "@cmddir@"/tg-$cmd ] || {
450                 echo "Unknown subcommand: $cmd" >&2
451                 do_help
452                 exit 1
453         }
454         . "@cmddir@"/tg-$cmd;;
455 esac
456
457 fi
458
459 # vim:noet